'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _WatchmanConnector = require('./WatchmanConnector');

var _WatchmanConnector2 = _interopRequireDefault(_WatchmanConnector);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var WatchmanWatchFileSystem = function () {
  function WatchmanWatchFileSystem(inputFileSystem, options) {
    _classCallCheck(this, WatchmanWatchFileSystem);

    this.inputFileSystem = inputFileSystem;
    this.options = options;
  }

  _createClass(WatchmanWatchFileSystem, [{
    key: 'watch',
    value: function watch(files, dirs, missing, startTime, options, callback, callbackUndelayed) {
      var _this = this;

      var oldWatcher = this.watcher;

      this.watcher = new _WatchmanConnector2.default(Object.assign({}, options, this.options));

      if (callbackUndelayed) {
        this.watcher.once('change', callbackUndelayed);
      }

      this.watcher.once('aggregated', function (changes) {
        if (_this.inputFileSystem && _this.inputFileSystem.purge) {
          _this.inputFileSystem.purge(changes);
        }

        var times = _this.watcher.getTimes();

        callback(null, changes.filter(function (file) {
          return files.indexOf(file) >= 0;
        }).sort(), changes.filter(function (file) {
          return dirs.indexOf(file) >= 0;
        }).sort(), changes.filter(function (file) {
          return missing.indexOf(file) >= 0;
        }).sort(), times, times);
      });

      this.watcher.watch(files.concat(missing), dirs, startTime);

      if (oldWatcher) oldWatcher.close();

      return {
        close: function close() {
          return _this.watcher.close();
        },
        pause: function pause() {
          return _this.watcher.pause();
        }
      };
    }
  }]);

  return WatchmanWatchFileSystem;
}();

exports.default = WatchmanWatchFileSystem;